//========================================================================================
//
//	File:				FWPPobOb.h
//	Release Version:	$ ODF 2 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPPOBOB_H
#define FWPPOBOB_H

#ifndef FWVIEW_H
#include "FWView.h"
#endif

#ifndef FWCONTRL_H
#include "FWContrl.h"
#endif

#ifndef FWBUTTON_H
#include "FWButton.h"
#endif

#ifndef FWPPOBRD_H
#include "FWPPobRd.h"
#endif

//========================================================================================
// Forward declarations
//========================================================================================

class FW_CReadableStream;
class FW_CSuperView;
class FW_CScrollBarScroller;
struct Environment;

//========================================================================================
// class FW_CPPobView
//========================================================================================

class FW_CPPobView 
{
public:
	FW_CPPobView(Environment* ev, FW_CReadableStream& stream);
	
//	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	FW_CSuperView*		fSuperView;
	ODID				fViewID;
	FW_CRect			fBounds;
	FW_ViewBinding		fBindings;
};

//========================================================================================
// class FW_CPPobView
//========================================================================================

class FW_CPPobSuperView : public FW_CPPobView
{
public:
	FW_CPPobSuperView(Environment* ev, FW_CReadableStream& stream);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);
	void				PostCreateODFView(Environment* ev, FW_CSuperView* view);

	FW_CPoint				fExtent;		
	FW_Boolean				fIsContentView;	 
	FW_EScrollingDirection	fScrollingDirection;
};

//========================================================================================
// class FW_CPPobEditView
//========================================================================================

class FW_CPPobEditView : public FW_CPPobView
{
public:
	FW_DECLARE_AUTO(FW_CPPobEditView)

	FW_CPPobEditView(Environment* ev, FW_CReadableStream& stream);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	FW_CString			fText;
	ResIDT				fTextTraitsID;
	short				fMaxChars;
	unsigned char		fAttributes;
	char				fKeyFilterID;
};

//========================================================================================
// class FW_CPPobTextEdit
//========================================================================================

class FW_CPPobTextEdit : public FW_CPPobSuperView
{
public:
	FW_DECLARE_AUTO(FW_CPPobTextEdit)

	FW_CPPobTextEdit(Environment* ev, FW_CReadableStream& stream);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	FW_CString			fText;
	ResIDT				fTextTraitsID;
	unsigned short		fAttributes;
};

//========================================================================================
// class FW_CPPobListBox
//========================================================================================

class FW_CPPobListBox : public FW_CPPobView
{
public:
	FW_DECLARE_AUTO(FW_CPPobListBox)

	FW_CPPobListBox(Environment* ev, FW_CReadableStream& stream);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	short				fNumRows;
	FW_Boolean			fScrollVert;
	ResIDT				fTextTraitsID;
	FW_Message			fDoubleClickMsg;
	FW_Boolean			fSingleSelection;
	FW_Boolean			fUseFocusFrame;
};

//========================================================================================
// class FW_CPPobStaticText
//========================================================================================

class FW_CPPobStaticText : public FW_CPPobView
{
public:
	FW_DECLARE_AUTO(FW_CPPobStaticText)

	FW_CPPobStaticText(Environment* ev, FW_CReadableStream& stream);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	FW_CString			fText;
	ResIDT				fTextTraitsID;
};

//========================================================================================
// class FW_CPPobGroupBox
//========================================================================================

class FW_CPPobGroupBox : public FW_CPPobStaticText
{
public:
	FW_DECLARE_AUTO(FW_CPPobGroupBox)

	FW_CPPobGroupBox(Environment* ev, FW_CReadableStream& stream);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

};

//========================================================================================
// class FW_CPPobControl
//========================================================================================

class FW_CPPobControl : public FW_CPPobView
{
public:
	FW_CPPobControl(Environment* ev, FW_CReadableStream& stream);

//	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
//	virtual void		CreateODFView(Environment* ev);

	FW_Message			fMessage;
	FW_ControlValue		fValue;
	FW_ControlValue		fMinValue;
	FW_ControlValue		fMaxValue;
};

//========================================================================================
// class FW_CPPobButton
//========================================================================================

class FW_CPPobButton : public FW_CPPobControl
{
public:
	FW_DECLARE_AUTO(FW_CPPobButton)

	FW_CPPobButton(Environment* ev, FW_CReadableStream& stream);
	
	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	FW_ButtonKind		fKind;
	FW_CString			fLabel;
	short				fTextTraitsID;
};

//========================================================================================
// class FW_CPPobPopupMenu
//========================================================================================

class FW_CPPobPopupMenu : public FW_CPPobControl
{
public:
	FW_DECLARE_AUTO(FW_CPPobPopupMenu)

	FW_CPPobPopupMenu(Environment* ev, FW_CReadableStream& stream);
	
	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	short				fControlKind;
	FW_CString			fLabel;
	short				fTextTraitsID;
	long				fRefCon;
	short				fInitialItem;
};

//========================================================================================
// class FW_CPPobScrollBarScroller
//========================================================================================

class FW_CPPobScrollBarScroller : public FW_CPPobSuperView
{
public:
	FW_CPPobScrollBarScroller(Environment* ev, FW_CReadableStream& stream, FW_Boolean liveScrolling);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);

	short			fHorizBarLeftIndent;
	short			fHorizBarRightIndent;
	short			fVertBarTopIndent;
	short			fVertBarBottomIndent;
	long			fScrollingViewID;
	FW_Boolean		fLiveScrolling;
	
	FW_CScrollBarScroller*	fODFScroller;
};

//========================================================================================
// class FW_CPPobPictSView
//========================================================================================

class FW_CPPobPictSView : public FW_CPPobSuperView
{
public:
	FW_CPPobPictSView(Environment* ev, FW_CReadableStream& stream, long type);

	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
	virtual void		CreateODFView(Environment* ev);
	
	ResIDT		fPictID;
};

//========================================================================================
// class FW_CPPobUnknownView
//========================================================================================

class FW_CPPobUnknownView : public FW_CPPobView
{
public:
	FW_CPPobUnknownView(Environment* ev, FW_CReadableStream& stream, long type);

	virtual void		CreateODFView(Environment* ev);
	
	long		fClassID;
};

//========================================================================================
// class FW_CPPobUnknownSView
//========================================================================================

class FW_CPPobUnknownSView : public FW_CPPobSuperView
{
public:
	FW_CPPobUnknownSView(Environment* ev, FW_CReadableStream& stream, long type);

	virtual void		CreateODFView(Environment* ev);

	long		fClassID;
};

//========================================================================================
// class FW_CPPobRadioCluster
//========================================================================================

class FW_CPPobRadioCluster 
{
public:
	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
};

//========================================================================================
// class FW_CPPobViewTabber
//========================================================================================

class FW_CPPobViewTabber 
{
public:
	static void*		Create(Environment* ev, FW_CReadableStream& stream, long type);
};


#endif
